# Differentiation

Documentation for `Manifolds.jl`'s methods and types for finite differences and automatic differentiation.

## Differentiation backends

```@autodocs
Modules = [Manifolds]
Pages = ["differentiation/differentiation.jl"]
Order = [:type, :function, :constant]
```

### ForwardDiff.jl

```@autodocs
Modules = [Manifolds]
Pages = ["differentiation/forward_diff.jl"]
Order = [:type, :function, :constant]
```

### FiniteDifferenes.jl

```@autodocs
Modules = [Manifolds]
Pages = ["differentiation/finite_differences.jl"]
Order = [:type, :function, :constant]
```

## Riemannian differentiation backends

```@autodocs
Modules = [Manifolds]
Pages = ["differentiation/riemannian_diff.jl"]
Order = [:type, :function, :constant]
```
